#!/usr/bin/perl
#ptm2pl is part of PerlTkMaker 
#under GNU GPL v2
#ptm2pl for PerlTkMaker v0.002
if(!$ARGV[0] || !$ARGV[1]) {
	print "usage: $0 ptm_file pl_file\n";
	exit(0);
}
#print "Ave Linuxoid!\n";
$PTM=$ARGV[0];
$PL=$ARGV[1];
##########
my @ptm_lines;												#mass with ptm lines
##########
open my $ptm_file, "< $PTM" or die "Eror of opening file: $!";
@ptm_lines=<$ptm_file>;
close $ptm_file or die "Eror of closing file: $!";
my $separator;												#Line of separator
my $number_of_lines;											#number of lines
my $i;my $j;
search_separator();
print "sep: $separator\n";
print "nu: $number_of_lines\n";
change_main_lines();
dodo_main_lines();
#writing to PL file...
open my $pl_file, "> $PL" or die "Eror of opening file: $!";
for($i=0; $i < $separator; $i++) {
	print $pl_file $ptm_lines[$i];
}
close $pl_file or die "Eror of closing file: $!";
#print "#########################################\n";
#print @ptm_lines;

################################################
sub search_separator {
	$number_of_lines=scalar @ptm_lines;
	for($separator=0; $separator < $number_of_lines; $separator++) {
		if($ptm_lines[$separator] eq "VALUES\n") { last; }
	}
}
sub change_main_lines {
	for($i=0; $i < $separator; $i++) {
		chomp $ptm_lines[$i];
		my $search_word=$ptm_lines[$i];
		print "search word: $search_word\n";
		for($j=$separator+1; $j < $number_of_lines; $j++) {
			if( $ptm_lines[$j]=~/$search_word/ ) {
				$ptm_lines[$i]=$ptm_lines[$j];
				print $ptm_lines[$i];
				remove_meta_name();
				last;
			}
		}
	}
}
sub remove_meta_name {
	$ptm_lines[$i]=~/\=\"/;
	print $';
	$'=~/\"/;
	$ptm_lines[$i]="$`\n";
	print $ptm_lines[$i];
}
sub dodo_main_lines {
	for($i=1; $i < $separator; $i++) {
		while( $ptm_lines[$i]=~/\%\w*/ ) {
			print "\n##########\n$&\n##########\n";
			##### ESCAPES ##### v0.02.2
			if($&=~/\%escape0/) {
				$ptm_lines[$i]=~/\%escape0/;
				$ptm_lines[$i]="$`\"$'";
				print "ptm_full".$ptm_lines[$i]."\n";
				next;
			}
			####### END #######
			search_meta_name();
		}
	}
}
sub search_meta_name {
	$ptm_lines[$i]=~/\%\w{1,}/;
	#if($ptm_lines[$i]=~/label/) {print $ptm_lines[$i]; exit(0);}
	my $before=$`;
	my $after=$';
	my $search_word=$&;
	for($j=$separator+1; $j < $number_of_lines; $j++) {
		if( $ptm_lines[$j]=~/$search_word\=/ ) {
			my $result=$ptm_lines[$j];
			$result=~/\=\"/;
			$'=~/\"/;
			$ptm_lines[$i]="$before$`$after";
			print "ptm_full".$ptm_lines[$i]."\n";
			last;
		}
	}
}
