#!/usr/bin/perl
###############
#PerlTkMaker
#GNU GPL v2
#View version in config.pl
use Tk;
use utf8;
do "config.pl";

##############
sub CreateWindow;
sub SetValues;
sub SaveProject;
sub LoadProject;
sub CreateProgramm;
sub StartProgramm;
sub CreateButton;
sub EditElement;
sub CreateFrame;
sub CreateLabel;
sub CreateText;
sub EditStarts;
sub EditLibs;
sub CreateEntry;
sub CreateList;
sub CreateScale;
sub CreateCanvas;
##############
#######
my @main_lines; my $mlcount=0;
my @lines; my $count=0;
my %prog;
my $PROJECT_NAME; my $saved=0; my $created=0;
#######
my @windows; my $wcount=0;
my @buttons; my $bcount=0;
my @frames; my $fcount=0;
my @labels; my $lcount=0;
my @texts; my $tcount=0;
my @entres; my $ecount=0;
my @lists; my $licount=0;
my @scales; my $scount=0;
my @canvases; my $ccount=0;
#######

#interface
my $leftW = MainWindow->new(-title=>'Инструменты - PerlTkMaker');
my $rightW = MainWindow->new(-title=>'Параметры - PerlTkMaker');
$leftW->geometry('200x600');
$rightW->geometry('200x600');
#Scheeme of right menu...
$rightW->Label(-text => 'Элементы')->pack;
$elements=$rightW->Listbox(-selectmode=>'single')->pack;
$rightW->Label(-text => 'Параметры')->pack;
my $frameText=$rightW->Frame()->pack;                                    # We will make frame to every line. It will make line Happy :D
$frameText->Label(-text => 'Текст:')->pack(-side=>'left');
my $ele_text=$frameText->Entry()->pack(-side=>'left');
my $frameX=$rightW->Frame()->pack;
$frameX->Label(-text => 'РазмерХ:')->pack(-side=>'left');
my $sizeX=$frameX->Entry()->pack(-side=>'left');
my $frameY=$rightW->Frame()->pack;
$frameY->Label(-text => 'РазмерY:')->pack(-side=>'left');
my $sizeY=$frameY->Entry()->pack(-side=>'left');
my $frameSide=$rightW->Frame()->pack;
$frameSide->Button(-text=>'Верх', -command=>sub { $ele_side="top"; })->pack(-side=>'top');
$frameSide->Button(-text=>'Низ', -command=>sub { $ele_side="bottom"; })->pack(-side=>'bottom');
$frameSide->Button(-text=>'Лево', -command=>sub { $ele_side="left"; })->pack(-side=>'left');
$frameSide->Button(-text=>'Право', -command=>sub { $ele_side="right"; })->pack(-side=>'right');
$framePropButtons=$rightW->Frame()->pack;
$framePropButtons->Button(-text=>'Применить', -command=>sub { 
	my @some=$elements->curselection();
	SetValues($elements->get( $some[0] ), $ele_text->get(), $sizeX->get(), $sizeY->get(), $ele_side); 
	})->pack(-side=>'top');

#scheeme of left menu...
my $menu_frame=$leftW->Frame(-relief=>'groove', -borderwidth=>'3')->pack;
my $menu_file=$menu_frame->Menubutton(-text=>'Файл')->pack(-side=>'left');
$menu_file->command(-label=>'Сохранить проект',-command=>sub { SaveProject; });
$menu_file->command(-label=>'Загрузить проект',-command=>sub { LoadProject; });
$menu_file->command(-label=>'Создать программу',-command=>sub { CreateProgramm; });
$menu_file->separator();
$menu_file->command(-label=>'Запустить программу',-command=>sub { StartProgramm; });
$menu_file->separator();
$menu_file->command(-label=>'Выход',-command=>sub { exit(0); });
my $menu_edit=$menu_frame->Menubutton(-text=>'Правка')->pack(-side=>'left');
$menu_edit->command(-label=>'Элемент',-command=>sub { EditElement; });
$menu_edit->command(-label=>'Стартовые',-command=>sub { EditStarts; });
$menu_edit->command(-label=>'Библиотеки',-command=>sub { EditLibs; });
$menu_edit->separator();
$menu_edit->command(-label=>'Параметры',-command=>sub { my @some=$elements->curselection();
	SetValues($elements->get( $some[0] ), $ele_text->get(), $sizeX->get(), $sizeY->get(), $ele_side); });
my $menu_info=$menu_frame->Menubutton(-text=>'Информация')->pack(-side=>'left');

$leftW->Label(-text => 'Инструменты')->pack;
my $frameInstruments=$leftW->Frame()->pack;
$frameInstruments->Button(-text=>'W', -command=>sub {CreateWindow;})->pack(-side=>'left');
$frameInstruments->Button(-text=>'B', -command=>sub {my @some=$elements->curselection(); CreateButton($elements->get( $some[0] ));})->pack(-side=>'left');
$frameInstruments->Button(-text=>'F', -command=>sub {my @some=$elements->curselection(); CreateFrame($elements->get( $some[0] ));})->pack(-side=>'left');
$frameInstruments->Button(-text=>'L', -command=>sub {my @some=$elements->curselection(); CreateLabel($elements->get( $some[0] ));})->pack(-side=>'left');
$frameInstruments->Button(-text=>'T', -command=>sub {my @some=$elements->curselection(); CreateText($elements->get( $some[0] ));})->pack(-side=>'left');
my $frameInstruments2=$leftW->Frame()->pack;
$frameInstruments2->Button(-text=>'E', -command=>sub {my @some=$elements->curselection(); CreateEntry($elements->get( $some[0] ));})->pack(-side=>'left');
$frameInstruments2->Button(-text=>'Li', -command=>sub {my @some=$elements->curselection(); CreateList($elements->get( $some[0] ));})->pack(-side=>'left');
$frameInstruments2->Button(-text=>'S', -command=>sub {my @some=$elements->curselection(); CreateScale($elements->get( $some[0] ));})->pack(-side=>'left');
$frameInstruments2->Button(-text=>'C', -command=>sub {my @some=$elements->curselection(); CreateCanvas($elements->get( $some[0] ));})->pack(-side=>'left');
#end of interface

#functions
#-----------------
$lines[$count]="\%libs=\"use utf8;use Tk;\"";
$prog{"libs"}=\$lines[$count];
$count++;
$main_lines[$mlcount]="\%libs";
$mlcount++;
#----------------
sub CreateWindow {
	#project
	$lines[$count]="\%window$wcount=\"\$window$wcount=MainWindow->new(-title=>\'\%twindow$wcount\'); \$window$wcount->geometry('\%gwindow$wcount');\"";
	$prog{"window$wcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%twindow$wcount=\"Window $wcount\"";
	$prog{"twindow$wcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%gwindow$wcount=\"300x300\"";
	$prog{"gwindow$wcount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%window$wcount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "window$wcount");
	#Visual
	$windows[$wcount]=MainWindow->new(-title=>"Window $wcount");
	$windows[$wcount]->geometry("300x300");
	$wcount++;	
}
sub SetValues {
	my $element_name=$_[0];
	if( $element_name =~/window/ ) {
		#project
		${$prog{"t$element_name"}}="\%t$element_name=\"".$_[1]."\"";
		${$prog{"g$element_name"}}="\%g$element_name=\"".$_[2]."x".$_[3]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$windows[$&]->configure(-title=>"".$_[1]."");
		$windows[$&]->geometry("".$_[2]."x".$_[3]."");
	}
	if( $element_name =~/button/ ) {
		#project
		${$prog{"t$element_name"}}="\%t$element_name=\"".$_[1]."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		#print $&;
		$buttons[$&]->configure(-text=>"".$_[1]."");
		$buttons[$&]->pack(-side=>"".$_[4]."");
	}
	if( $element_name =~/frame/ ) {
		#project
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$frames[$&]->pack(-side=>"".$_[4]."");
	}
	if( $element_name =~/label/ ) {
		#project
		${$prog{"t$element_name"}}="\%t$element_name=\"".$_[1]."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$labels[$&]->configure(-text=>"".$_[1]."");
		$labels[$&]->pack(-side=>"".$_[4]."");
	}
	if( $element_name =~/text/ ) {
		#project
		${$prog{"w$element_name"}}="\%w$element_name=\"".$_[2]."\"";
		${$prog{"h$element_name"}}="\%h$element_name=\"".$_[3]."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$texts[$&]->configure(-width=>"".$_[2]."",-height=>"".$_[3]."");
		$texts[$&]->pack(-side=>"".$_[4]."");
	}
	if( $element_name =~/entry/ ) {
		#project
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$entres[$&]->pack(-side=>"".$_[4]."");
	}
	if( $element_name =~/list/ ) {
		#project
		${$prog{"w$element_name"}}="\%w$element_name=\"".$_[2]."\"";
		${$prog{"h$element_name"}}="\%h$element_name=\"".$_[3]."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$lists[$&]->configure(-width=>"".$_[2]."",-height=>"".$_[3]."");
		$lists[$&]->pack(-side=>"".$_[4]."");
	}
	if( $element_name =~/scale/ ) {
		#project
		${$prog{"f$element_name"}}="\%f$element_name=\"".$_[2]."\"";
		${$prog{"t$element_name"}}="\%t$element_name=\"".$_[3]."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$scales[$&]->configure(-from=>"".$_[2]."",-to=>"".$_[3]."");
		$scales[$&]->pack(-side=>"".$_[4]."");
	}
	if( $element_name =~/canvas/ ) {
		#project
		${$prog{"w$element_name"}}="\%w$element_name=\"".$_[2]."\"";
		${$prog{"h$element_name"}}="\%h$element_name=\"".$_[3]."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$_[4]."\"";
		#Visual
		$element_name=~/\d{1,}/;
		$canvases[$&]->configure(-width=>"".$_[2]."",-height=>"".$_[3]."");
		$canvases[$&]->pack(-side=>"".$_[4]."");
	}
}
sub SaveProject {
	my $save_dialog=MainWindow->new(-title=>"Сохранить проект");
	$save_dialog->Label(-text=>"Введите имя проекта, после сохранения он появится в текущей папке")->pack;
	$project_name=$save_dialog->Entry()->pack;
	$save_dialog->Button(-text=>"Сохранить", -command=>sub { 
		open my $save_file, "> ".$project_name->get().".ptm" or die "Ошибка создания проекта: $!";
		for(my $i=0; $i < $mlcount; $i++) {
			print $save_file "".$main_lines[$i]."\n";
		}
		if($prog{"starts"}) {print $save_file "\%starts\n";}
		print $save_file "\%end\n";
		##
		print $save_file "VALUES\n";
		##
		for(my $i=0; $i < $count; $i++) {
			print $save_file "".$lines[$i]."\n";
		}
		print $save_file $prog{"starts"};
		print $save_file "%end=\"MainLoop;\"";
		close $save_file;
		$PROJECT_NAME=$project_name->get();
		$save_dialog->destroy();
	})->pack;
	$saved=1;
}
sub CreateProgramm {
	if(!$saved) {
		SaveProject;
	} else {
		`perl ptm2pl.pl $PROJECT_NAME.ptm $PROJECT_NAME.pl`;
		my $created_dialog=MainWindow->new(-title=>"Программа создана");
		$created_dialog->Label(-text=>"Программа $PROJECT_NAME.pl создана!")->pack;
		$created_dialog->Button(-text=>"OK", -command=>sub{ $created_dialog->destroy(); })->pack;
	}
	$created=1;
}
sub StartProgramm {
	if(!$created) {
		CreateProgramm;
	} else {
		`perl $PROJECT_NAME.pl`;
	}
}
sub GetMetaData {
	$_[0]=~/\=\"/;
	$'=~/\"/;
	return $`;
}
sub GetMeta {
	my $meta;
	my $i=0;
	while( $loaded[$i] != "VALUES\n" ) {$i++}
	for( ; ; $i++) {
		if($loaded[$i] =~/\%$_[0]\=/) {
			$meta=GetMetaData( $loaded[$i] );
			last;
		}
	}
	return $meta;
}
sub LoadProject {
	$load_dialog=MainWindow->new(-title=>"Загрузить проект");
	$load_dialog->Label(-text=>"Введите имя загружаемого проекта:")->pack;
	$load_name=$load_dialog->Entry()->pack;
	$load_dialog->Button(-text=>"Ok", -command=>sub{
		my $load_file=$load_name->get();
		open my $file, "< $load_file.ptm";
		our @loaded=<$file>;
		close $file;
		my $loa_size=scalar @loaded;
		for( my $i=0; !($loaded[$i] eq "VALUES\n"); $i++) {
			if( $loaded[$i]=~/window\d{1,}/ ) {
				my $melement=$&;
				CreateWindow;
				my $gwindow=GetMeta("g$melement");
				$gwindow=~/x/;
				SetValues($melement, GetMeta("t$melement"), "$`", "$'", "");
			}
			if( $loaded[$i]=~/button\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateButton($&);
				SetValues($melement, GetMeta("t$melement"), "", "", GetMeta("s$melement"));
				${$prog{"c$melement"}}="\%c$melement=\"".GetMeta("c$melement")."\"";
			}
			if( $loaded[$i]=~/frame\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateFrame($&);
				SetValues($melement, "", "", "", GetMeta("s$melement"));
			}
			if( $loaded[$i]=~/label\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateLabel($&);
				SetValues($melement, GetMeta("t$melement"), "", "", GetMeta("s$melement"));
			}
			if( $loaded[$i]=~/text\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateText($&);
				SetValues($melement, "", GetMeta("w$melement"), GetMeta("h$melement"), GetMeta("s$melement"));
			}
			if( $loaded[$i]=~/entry\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateEntry($&);
				SetValues($melement, "", "", "", GetMeta("s$melement"));
			}
			if( $loaded[$i]=~/list\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateList($&);
				SetValues($melement, "", GetMeta("w$melement"), GetMeta("h$melement"), GetMeta("s$melement"));
			}
			if( $loaded[$i]=~/scale\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateScale($&);
				SetValues($melement, "", GetMeta("f$melement"), GetMeta("t$melement"), GetMeta("s$melement"));
			}
			if( $loaded[$i]=~/canvas\d{1,}/ ) {
				my $melement=$&;
				GetMeta("$melement")=~/\w{1,}\-\>/;
				$&=~/\w{1,}/;
				CreateCanvas($&);
				SetValues($melement, "", GetMeta("w$melement"), GetMeta("h$melement"), GetMeta("s$melement"));
			}
		}
		${$prog{"libs"}}="\%libs=\"".GetMeta("libs")."\"";
		for(my $i=0; $i < $loa_size; $i++) {
			if( $loaded[$i] =~/\%starts/ ) {
				$prog{"starts"}="\%starts=\"".GetMeta("starts")."\"\n";
				print $prog{"starts"};
				last;
			}
		}
		$load_dialog->destroy();
	})->pack;
}
sub CreateFrame {
	#project
	$lines[$count]="\%frame$fcount=\"\$frame$fcount=\$".$_[0]."->Frame()->pack(-side=>\'%sframe$fcount\');\"";
	$prog{"frame$fcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%sframe$fcount=\"top\"";
	$prog{"sframe$fcount"}=\$lines[$count];
	$count++;
	#-----------
	$main_lines[$mlcount]="\%frame$fcount";
	$mlcount++;
	#Elements
	$elements->insert('end', "frame$fcount");
	#Visual
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$frames[$fcount]=$windows[$&]->Frame()->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$frames[$fcount]=$frames[$&]->Frame()->pack;
	}
	$fcount++;
}
sub CreateLabel {
	#project
	$lines[$count]="\%label$lcount=\"\$label$lcount=\$".$_[0]."->Label(-text=>\'%tlabel$lcount\')->pack(-side=>\'%slabel$lcount\');\"";
	$prog{"label$lcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%tlabel$lcount=\"Label $lcount\"";
	$prog{"tlabel$lcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%slabel$lcount=\"top\"";
	$prog{"slabel$lcount"}=\$lines[$count];
	$count++;
	#------------
	$main_lines[$mlcount]="\%label$lcount";
	$mlcount++;
	#Elements
	$elements->insert('end', "label$lcount");
	#Visual
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$labels[$lcount]=$windows[$&]->Label(-text=>"Label $lcount")->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$labels[$lcount]=$frames[$&]->Label(-text=>"Label $lcount")->pack;
	}
	$lcount++;
}
sub CreateText {
	#project
	$lines[$count]="\%text$tcount=\"\$text$tcount=\$".$_[0]."->Text(-width=>\'%wtext$tcount\',-height=>\'%htext$tcount\')->pack(-side=>\'%stext$tcount\');\"";
	$prog{"text$tcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%wtext$tcount=\"10\"";
	$prog{"wtext$tcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%htext$tcount=\"10\"";
	$prog{"htext$tcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%stext$tcount=\"top\"";
	$prog{"Htext$tcount"}=\$lines[$count];
	$count++;
	#---------------
	$main_lines[$mlcount]="\%text$tcount";
	$mlcount++;
	#Elements
	$elements->insert('end', "text$tcount");
	#Visual
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$texts[$tcount]=$windows[$&]->Text(-width=>'10',-height=>'10')->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$texts[$tcount]=$frames[$&]->Text(-width=>'10',-height=>'10')->pack;
	}
	$tcount++;
}
sub CreateEntry {
	$lines[$count]="\%entry$ecount=\"\$entry$ecount=\$".$_[0]."->Entry()->pack(-side=>\'%sentry$ecount\');\"";
	$prog{"entry$ecount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%sentry$ecount=\"top\"";
	$prog{"sentry$ecount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%entry$ecount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "entry$ecount");
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$entres[$ecount]=$windows[$&]->Entry()->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$entres[$ecount]=$frames[$&]->Entry()->pack;
	}
	$ecount++;
}
sub CreateList {
	#project
	$lines[$count]="\%list$licount=\"\$list$licount=\$".$_[0]."->Listbox(-width=>\'%wlist$licount\',-height=>\'%hlist$licount\')->pack(-side=>\'%slist$licount\');\"";
	$prog{"list$licount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%wlist$licount=\"10\"";
	$prog{"wlist$licount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%hlist$licount=\"10\"";
	$prog{"hlist$licount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%slist$licount=\"top\"";
	$prog{"slist$licount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%list$licount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "list$licount");
	#Visual
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$lists[$licount]=$windows[$&]->Listbox(-width=>"10", -height=>"10")->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$lists[$licount]=$frames[$&]->Listbox(-width=>"10", -height=>"10")->pack;
	}
	$licount++;
}
sub CreateScale {
	#project
	$lines[$count]="\%scale$scount=\"\$scale$scount=\$".$_[0]."->Scale(-from=>\'%fscale$scount\',-to=>\'%tscale$scount\')->pack(-side=>\'%sscale$scount\');\"";
	$prog{"button$bcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%fscale$scount=\"0\"";
	$prog{"fscale$scount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%tscale$scount=\"10\"";
	$prog{"tscale$scount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%sscale$scount=\"top\"";
	$prog{"sscale$scount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%scale$scount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "scale$scount");
	#Visual
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$scales[$scount]=$windows[$&]->Scale(-from=>"0",-to=>"10")->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$scales[$scount]=$frames[$&]->Scale(-from=>"0",-to=>"10")->pack;
	}
	$scount++;
}
sub CreateCanvas {
	#project
	$lines[$count]="\%canvas$ccount=\"\$canvas$ccount=\$".$_[0]."->Canvas(-width=>\'%wcanvas$ccount\',-height=>\'%hcanvas$ccount\')->pack(-side=>\'%scanvas$ccount\');\"";
	$prog{"canvas$ccount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%wcanvas$ccount=\"50\"";
	$prog{"wcanvas$ccount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%hcanvas$ccount=\"50\"";
	$prog{"hcanvas$ccount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%scanvas$ccount=\"top\"";
	$prog{"scanvas$ccount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%canvas$ccount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "canvas$ccount");
	#Visual
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$canvases[$ccount]=$windows[$&]->Canvas(-width=>"50",-height=>"50")->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$canvases[$ccount]=$frames[$&]->Canvas(-width=>"50",-height=>"50")->pack;
	}
	$ccount++;	
}
sub CreateButton {
	#my @some=$elements->curselection();
	#project
	$lines[$count]="\%button$bcount=\"\$button$bcount=\$".$_[0]."->Button(-text=>\'%tbutton$bcount\',-command=>sub{%cbutton$bcount})->pack(-side=>\'%sbutton$bcount\');\"";
	$prog{"button$bcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%tbutton$bcount=\"Button $bcount\"";
	$prog{"tbutton$bcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%cbutton$bcount=\"\"";
	$prog{"cbutton$bcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%sbutton$bcount=\"top\"";
	$prog{"sbutton$bcount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%button$bcount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "button$bcount");
	#Visual
	if($_[0]=~/window/) {
		$_[0]=~/\d{1,}/;
		$buttons[$bcount]=$windows[$&]->Button(-text=>"Button $bcount")->pack;
	}
	if($_[0]=~/frame/) {
		$_[0]=~/\d{1,}/;
		$buttons[$bcount]=$frames[$&]->Button(-text=>"Button $bcount")->pack;
	}
	$bcount++;	
}
sub SetEscapes {
	open my $temp, "< temp.pl" or die "$!";
	my @code=<$temp>;
	close $temp  or die "$!";
	$code_size=scalar @code;
	for(my $i=0; $i<$code_size; $i++) {
		while($code[$i]=~/\"/) {
			$code[$i]="$` %escape0 $'";
		}
	}
	open my $temp, "> temp.pl" or die "$!";
	for(my $i=0; $i<$code_size; $i++) {
		print $temp $code[$i];
	}
	close $temp  or die "$!";
}
sub DelEscapes {
	open my $temp, "< temp.pl" or die "$!";
	my @code=<$temp>;
	close $temp  or die "$!";
	$code_size=scalar @code;
	for(my $i=0; $i<$code_size; $i++) {
		while($code[$i]=~/\%escape0/) {
			$code[$i]="$`\"$'";
		}
	}
	open my $temp, "> temp.pl" or die "$!";
	for(my $i=0; $i<$code_size; $i++) {
		print $temp $code[$i];
	}
	close $temp  or die "$!";
}
sub EditElement {
	my @some=$elements->curselection();
	open my $temp, "> temp.pl" or die "$!";
	my $element_name=$elements->get( $some[0] );
	$src=${$prog{"c$element_name"}};
	$src=~/\=\"/;
	$'=~/\"/;
	print $temp "$`";
	close $temp  or die "$!";
	DelEscapes;
	`$default_editor temp.pl`;
	SetEscapes;
	my $script="";
	open my $temp2, "< temp.pl" or die "$!";
	my @code=<$temp2>;
	close $temp2  or die "$!";
	print @code;
	$code_size=scalar @code;
	for(my $i; $i < $code_size; $i++) {
		chomp $code[$i];
		$script="$script".$code[$i]."";
	}
	${$prog{"c".$elements->get( $some[0] ).""}}="\%c".$elements->get( $some[0] )."=\"$script\"";
	
}
sub EditStarts {
	open $temp, "> temp.pl";
	$src="%starts=\"\"";
	$src=~/\=\"/;
	$'=~/\"/;
	print $temp "$`";
	close $temp;
	DelEscapes;
	`$default_editor temp.pl`;
	SetEscapes;
	my $script="";
	open $temp, "temp.pl";
	@code=<$temp>;
	$code_size=scalar @code;
	for(my $i; $i < $code_size; $i++) {
		chomp $code[$i];
		$script="$script".$code[$i]."";
	}
	close $temp;
	$prog{"starts"}="\%starts=\"$script\"\n";
}
sub EditLibs {
	open $temp, "> temp.pl";
	$src=${$prog{"libs"}};
	$src=~/\=\"/;
	$'=~/\"/;
	print $temp "$`";
	close $temp;
	`$default_editor temp.pl`;
	my $script="";
	open $temp, "temp.pl";
	@code=<$temp>;
	$code_size=scalar @code;
	for(my $i; $i < $code_size; $i++) {
		chomp $code[$i];
		$script="$script".$code[$i]."";
	}
	close $temp;
	${$prog{"libs"}}="\%libs=\"$script\"";
}
#end of functions;

MainLoop;
